#!/bin/bash

# Apply linters and auto-formaters before a commit
# It generates a report for each language it lints
# All reports are cleaned when it succeeds
#
# Environment variables:
#  FORMATTING: will commit automatically the changes if set to 'a'
#              otherwise it will abort the commit
#              choices: [A]bort, [I]gnore, [M]anual, [?] ask (default)
#  CHECKING:   will check staged files or those from the latest commit
#              choices: [S]taged (default), [L]atest, [A]ll
#
# How to add a new language?
# --------------------------
# 1. Add a function `useLinter`
#    - that takes a file and a report as arguments
#    - that executes a corresponding linter
# 2. Apply the `lintAndFormat` in the `lintAll` function with
#    - the name of your language
#    - a regex that filter the files written with your new language
#    - your `useLinter` function
# 3. Remove your generated report in the `removeAll` function
# 4. Check the linter warnings in the `checkAll` function
# 5. Add a documentation in the **languages** section of the `README` about:
#    - the linter installation
#    - the linter configuration

set -u
set -o pipefail

: "${FORMATTING:=?}"
: "${CHECKING:=S}"

#######################################
# Prints errors nicely
# Returns:
#   A red message
#######################################
echoError () {
  local red='\033[0;31m'
  local default='\033[0m'

  echo -e "Error: $red$1$default"
}

#######################################
# Prints infos nicely
# Returns:
#   A blue message
#######################################
echoInfo () {
  local blue='\e[0;36m'
  local default='\033[0m'

  echo -e "Info: $blue$1$default"
}

#######################################
# Checks linter command
# Arguments:
#   A command name
# Returns:
#   True if the command exists
#######################################
checkCommand () {
  command -v "$1" >/dev/null 2>&1
}

#######################################
# Checks if python module exists
# Arguments:
#   A python module
# Returns:
#   True if the module exists
#######################################
checkModule () {
  python3 -c "import $1" >/dev/null 2>&1
}

#######################################
# Checks if a file has been modified by formatter
# Arguments:
#   A file path
# Returns:
#   True if the file is modified
#######################################
checkModifiedFile () {
  git status -s | grep -q "AM $1"
}

#######################################
# Gets all changed files in the commit
# Arguments:
#   Language filter
# Returns:
#   All staged files
#######################################
filterFiles () {
  local way="$CHECKING"
  local files

  if [ "$way" == "L" ]; then
    local hash

    hash="$(git log -n 1 --pretty=format:%H)"
    files="$(git diff-tree --no-commit-id --name-only -r "${hash}")"
  elif [ "$way" == "A" ]; then
    files="$(find . -type f ! -path "./.git/*")"
  else
    files="$(git diff --name-only --cached --relative)"
  fi

  if [ "$#" -eq "1" ]; then
    files="$(echo "$files" | grep "$1")"
  fi

  echo "$files"
}

#######################################
# Counts the errors from linters
# Arguments:
#   Path of the report file
# Returns:
#   Number of errors generated by linter
#######################################
countLinterErrors () {
  if [ -f "$1" ]; then
    sed '/^$/d' "$1" | wc -l
  else
    return 0
  fi
}

#######################################
# Prints the output of the linters
# Arguments:
#   Name of the linter
#   Path of the report fil
# Returns:
#   True if the linter gives no error
#######################################
printLinterOutput () {
  local linterName="$1"
  local linterReport="$2"
  local errorCount

  errorCount="$(countLinterErrors "$2")"

  if [[ "$errorCount" -ne 0 ]]; then
    echoError "$linterName errors were detected"

    while IFS= read -r error; do
      echo " $error"
    done < <(grep -v '^ *#' < "$linterReport")
  fi
}

#######################################
# Lints and formats specified language
# Arguments:
#   Name of the linter
#   Language filter
#   Path to linter report
#   Function that uses a specific linter
# Returns:
#   True if the linter gives no error
#######################################
lintAndFormat () {
  local name="$1"
  local filter="$2"
  local report="$3"

  local files
  local detected

  files="$(filterFiles "$filter")"
  detected="$(echo "$files" | tr -s \\n ' ')"

  if [ -n "$files" ]; then
    echoInfo "detected $name files: $detected"

    while IFS= read -r file; do
      ($4 "$file" "$report")

      if checkModifiedFile "$file"; then
        echoInfo "$file is modified by formatting"
        askFormatting "$file" "$report"
      fi
    done <<< "$files"

    printLinterOutput "$name" "$report"
  else
    return 0
  fi
}

#######################################
# Asks for the way to format a file
# Arguments:
#   File that is formated
#   Path to linter report
# Globals:
#   FORMATTING: preset the formatting choice
# Returns:
#   True if the linter gives no error
#######################################
askFormatting () {
  local way="$FORMATTING"

  local file="$1"
  local report="$2"

  if [ "$way" == "?" ]; then
    echo "A) Do automatic formatting and commit it"
    echo "I) (not recommended) Ignoring the formatting and committing files as-is"
    echo "M) (default) Abort the commit and await manual changes"
    read -rp "Choose how to react with formatting:" way < /dev/tty
  fi

  case "$way" in
    [Aa]) git add "$file";;
    [Ii]) echoInfo "Ignore changes of $file";;
    *) echo "$file" >> "$report";;
  esac
}

#######################################
# Uses StandardJS linter for all javascript code
# Should be used with standardjs
# Install dependencies with: npm install -g standardjs
# See https://standardjs.com/ for more information
# Arguments:
#   js file to lint
#   Path of the report file
#######################################
useStandardJS () {
  if checkCommand "npx"; then
    npx standard --fix "$1" 2> /dev/null >> "$2"
  else
    echoError "StandardJS is not available"
  fi
}

#######################################
# Uses Stylelint linter for all scss code
# Should be used with stylelint stylelint-scss stylelint-config-standard-scss
# Install dependencies with: npm i stylelint stylelint-scss stylelint-config-standard-scss
# See https://stylelint.io/ for more information
# Arguments:
#   css/scss file to lint
#   Path of the report file
#######################################
useStylelint () {
  if checkCommand "npx"; then
    npx stylelint --fix "$1" 2> /dev/null >> "$2"
  else
    echoError "Stylelint is not available"
  fi
}

#######################################
# Uses Markdownlint linter for all md files
# Install dependencies with: npm i markdownlint
# See https://github.com/DavidAnson/markdownlint for more information
# Arguments:
#   md file to lint
#   Path of the report file
#######################################
useMarkdownlint () {
  if checkCommand "npx"; then
    npx markdownlint-cli --fix "$1" >> "$2"
  else
    echoError "markdownlint is not available"
  fi
}

#######################################
# Uses autopep8 auto-formater for all python code
# Install dependencies with: pip3 install autopep8 flake8
# See https://pypi.org/project/autopep8/ for more information
# Arguments:
#   python file to lint
#   Path of the report file
#######################################
usePEP8 () {
  if checkModule "autopep8"; then
    python3 -m autopep8 -i "$1"
  else
    echoError "autopep8 is not available"
  fi

  if checkModule "flake8"; then
    python3 -m flake8 "$1" 2> /dev/null >> "$2"
  else
    echoError "flake8 is not available"
  fi
}

#######################################
# Uses ShellCheck linter for all bash scripts
# Install it with: sudo apt install shellcheck
# See https://www.shellcheck.net/ for more information
# Arguments:
#   sh file to lint
#   Path of the report file
#######################################
useShellCheck () {
  if checkCommand "shellcheck"; then
    shellcheck "$1" 2> /dev/null >> "$2"
  else
    echoError "Shellcheck is not available"
  fi
}

#######################################
# Uses clang-format format for all cpp files
# Install it with: sudo apt install clang-format
# See https://clang.llvm.org/docs/ClangFormat.html for more information
# Arguments:
#   cpp/hpp/h/cc file to lint
#   Path of the report file
#######################################
useClangFormat () {
  if checkCommand "clang-format"; then
    clang-format -i "$1" 2> /dev/null
  else
    echoError "ClangFormat is not available"
  fi
}

#######################################
# Uses hadolint format for all dockerfiles
# Use it with the docker image hadolint/hadolint
# See https://github.com/hadolint/hadolint for more information
# Arguments:
#   dockerfile to lint
#   Path of the report file
#######################################
useHadolint () {
  if checkCommand "docker"; then
    docker run --rm -i hadolint/hadolint < "$1" > "$2"
  elif checkCommand "hadolint"; then
    hadolint "$1" > "$2"
  else
    echoError "hadolint is not available"
  fi
}

#######################################
# Lints and formats all languages if detected
#######################################
lintAll() {
  lintAndFormat 'Javascript' '\.m\?jsx\?$' 'standard.txt' useStandardJS
  lintAndFormat 'CSS' '\.s\?css$' 'stylelint.txt' useStylelint
  lintAndFormat 'PEP8' '\.py$' 'pep8.txt' usePEP8
  lintAndFormat 'Shell scripts' '\.sh$' 'shellcheck.txt' useShellCheck
  lintAndFormat 'C++' '\.[c|h]p\?p\?c\?$' 'clang-format.txt' useClangFormat
  lintAndFormat 'Dockerfile' '\.\?d\?D\?ockerfile$' 'hadolint.txt' useHadolint
  lintAndFormat 'Markdown' '\.md$' 'markdownlint.txt' useMarkdownlint
}

#######################################
# Checks all linter reports
#######################################
checkAll() {
  [[ $(countLinterErrors 'standard.txt') -eq 0 ]] && \
    [[ $(countLinterErrors 'stylelint.txt') -eq 0 ]] && \
    [[ $(countLinterErrors 'pep8.txt') -eq 0 ]] && \
    [[ $(countLinterErrors 'shellcheck.txt') -eq 0 ]] && \
    [[ $(countLinterErrors 'clang-format.txt') -eq 0 ]] && \
    [[ $(countLinterErrors 'hadolint.txt') -eq 0 ]] && \
    [[ $(countLinterErrors 'markdownlint.txt') -eq 0 ]]
}

#######################################
# Removes all linter reports
#######################################
removeAll () {
  rm -f 'standard.txt'
  rm -f 'stylelint.txt'
  rm -f 'pep8.txt'
  rm -f 'shellcheck.txt'
  rm -f 'clang-format.txt'
  rm -f 'hadolint.txt'
  rm -f 'markdownlint.txt'
}

removeAll
lintAll

if checkAll; then
  removeAll
  echoInfo "no error is detected"
else
  echoError "aborting commit :("
  exit 1
fi
